@using Jones.AspNetCore.Utils
@using Microsoft.JSInterop
@using Jones.AspNetCore.TailwindCSS.FlowBite.Extensions
@inherits JonesComponentBase

<div id="@Id" role="tooltip" @attributes="@AdditionalAttributes" class="@Class">
    @ChildContent
    <div class="tooltip-arrow" data-popper-arrow></div>
</div>

@inject IJSRuntime JsRuntime
@code {
    private string? Class => CssBuilder.Default("absolute z-10 invisible inline-block px-3 py-2 text-sm font-medium text-white transition-opacity duration-300 bg-gray-900 rounded-lg shadow-sm opacity-0 tooltip dark:bg-gray-700")
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();
    
    [Parameter]
    public string Id { get; set; }
    
    [Parameter]
    public RenderFragment? ChildContent { get; set; }
    
    private IJSObjectReference? _tooltip;
    
    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);

        if (firstRender && OperatingSystem.IsBrowser())
        {
            _tooltip = await JsRuntime.CreateTooltips(Id);
        }
    }
}